/***************************************************************

This is a data accumulator for the CES system. I'd have used a 
 regular array, but I thought this would be more expandable
 should I make ANOTHER structure change later.
 
 Dec 28 2002. Dan, 
 Jul 05 2002. dan, overhauled 
 Aug 02 2002. dan, variable type overhaul.
 Nov 24 2002. Dan, added SerialNumber
 Nov 15 2010, Dan, converted to C, again.

***************************************************************/

#include "returnValues.h"

#ifndef _ACCUMULATOR
#define _ACCUMULATOR


#define BLOCK     512
#define AOffset_t long
#define ASerial_t long  

#define TACGetSize(a)  ((a)->contentSize)


typedef struct tac_s {
  char *     contents;
  long       contentSize;
  long       blockCount;
  ASerial_t  SerialNumber;
} tac_t;


Status_t          TACInit            ( tac_t * this);
Status_t          TACFini            ( tac_t * this);
Status_t          TACReadN           ( tac_t * this, AOffset_t position, char * buffer, AOffset_t size, AOffset_t * returnSize );
Status_t          TACSetN            ( tac_t * this, AOffset_t destStart, AOffset_t destSize, char * src, AOffset_t srcSize );  
Status_t          TACReSize          ( tac_t * this, AOffset_t newBlockSize );
Status_t          TACshift           ( tac_t * this, AOffset_t offset , AOffset_t delta );

Status_t TACCountOccurances ( tac_t * this, char c, AOffset_t * count );
#endif
